; ##############################################################################
; ##############################################################################
; ##############################################################################
; INITIALISIERUNG																
;																				
ONE_WIRE_INITIALISIERUNG:
	cbi (ONE_WIRE_DDR), (ONE_WIRE_PORTBIT)	; AUF EINGANG	
	cbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; PULL-UP aus	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 DATENBYTE 1-wire schreiben													
;																				
; Hier kommt es auf Zeiten an, stimmen die Zeiten nicht, werden die BITs vom	
; MASTER an den SLAVE nicht genau gelesen ! (ggf. mit OSZI prfen)				
;																				
; inp: temp1																	
;																				
; rcall DS_DATA_WRITE		; inp: temp1										
;																				
ONE_WIRE_DATA_WRITE:
	LSR temp1						; 1x rechts 1 rollt raus (LSB)
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-0 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-1 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-2 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-3 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-4 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-5 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus 	
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-6 schreiben			
	LSR temp1						; 1x rechts 1 rollt raus (MSB)
	rcall ONE_WIRE_DATA_WRITE_BIT	; BIT-7 schreiben			
ret
;-------------------------------------------------------------------------------
; DATEN-BIT schreiben															
; INP: CARRY																	
;																				
; rcall ONE_WIRE_DATA_WRITE_BIT		; INP: Carry								
;																				
ONE_WIRE_DATA_WRITE_BIT:
	; CARRY auswerten													
	brcs ONE_WIRE_DATA_WRITE_BIT_HIGH		; wenn CARRY=1 dann HIGH	
	rjmp ONE_WIRE_DATA_WRITE_BIT_LOW		; wenn CARRY=0 dann LOW 	
;-------------------------------------------------------------------------------
ONE_WIRE_DATA_WRITE_BIT_LOW:
	; "0" SLOT 60s (LOW-PEGEL)											
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 				
	sbi (ONE_WIRE_DDR) ,(ONE_WIRE_PORTBIT)	; AUF AUSGANG				
	cbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; LOW-PEGEL					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	; mind. 10s (HIGH-PEGEL)											
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 				
	;cbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; PULL-UP aus				
	rcall WAIT_10us							; PAUSE 					
ret
;-------------------------------------------------------------------------------
ONE_WIRE_DATA_WRITE_BIT_HIGH:
	; "1" SLOT 5s (LOW-PEGEL)											
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 				
	sbi (ONE_WIRE_DDR) ,(ONE_WIRE_PORTBIT)	; AUF AUSGANG				
	cbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; LOW-PEGEL					
	rcall WAIT_5us							; PAUSE						
	; mind. 64s (HIGH-PEGEL)											
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL 				
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
	rcall WAIT_10us							; PAUSE 					
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 1 DATENBYTE 1-wire lesen														
;																				
; Hier kommt es auf Zeiten an, stimmen die Zeiten nicht, werden die BITs vom	
; SLAVE nicht genau gelesen ! (ggf. mit OSZI prfen)							
;																				
; out: temp1																	
;																				
; rcall ONE_WIRE_DATA_READ		; OUT: temp1									
;																				
ONE_WIRE_DATA_READ:
	clr temp1

	rcall ONE_WIRE_DATA_READ_BIT	; LSB					
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	rcall ONE_WIRE_DATA_READ_BIT
	ROR temp1						; 1x rechts ber CARRY 	
	ret
;-------------------------------------------------------------------------------
; ein BIT vom SLAVE einlesen													
;																				
; OUT: CARRY																	
;																				
; rcall ONE_WIRE_DATA_READ_BIT		; OUT: CARRY 								
;																				
ONE_WIRE_DATA_READ_BIT:
	; kurzer LOW-IMPULS 1...5s									
	sbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; HIGH-PEGEL (PULL-UP_EIN)	
	sbi (ONE_WIRE_DDR) ,(ONE_WIRE_PORTBIT)	; AUF AUSGANG	
	cbi (ONE_WIRE_PORT),(ONE_WIRE_PORTBIT)	; LOW-PEGEL		
	; diese Pause ist kritisch, hier ggf. nachbessern		
	rcall WAIT_5us					; 5s PAUSE				
	cbi (ONE_WIRE_DDR), (ONE_WIRE_PORTBIT)	; AUF EINGANG	
	; diese Pause ist kritisch, hier ggf. nachbessern		
	rcall WAIT_10us							; ca 10s warten
	; MASTER SAMPLES			
	sbic (ONE_WIRE_PIN),(ONE_WIRE_PORTBIT) 	; "skip if..."
	rjmp ONE_WIRE_DATA_READ_1_SLOT
	rjmp ONE_WIRE_DATA_READ_0_SLOT
;-------------------------------------------------------------------------------
ONE_WIRE_DATA_READ_0_SLOT:
	rcall WAIT_100us						; warten		
	CLC										; CARRY clear	
	ret
;-------------------------------------------------------------------------------
ONE_WIRE_DATA_READ_1_SLOT:
	rcall WAIT_100us						; warten		
	SEC										; CARRY setzen	
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
