; ##############################################################################
; ##############################################################################
; ##############################################################################
USART_INITIALISIEREN:
	ldi temp,TAKT/(BAUD*16)-1  		; Baudrate 								
	out UBRRL,temp
   	ldi temp, (1<<URSEL)|(3<<UCSZ0)	; Frame-Format: 8 Bit					
    out UCSRC, temp
    sbi UCSRB, RXCIE                ; Interrupt bei Empfang	aktivieren		
    sbi UCSRB, RXEN 				; RX aktivieren (Empfang)      			
	sbi UCSRB, TXEN  				; TX aktivieren                 		
ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; 	INPUT: temp1														
;																		
;	rcall SENDEN	; INP: TEMP1										
;																		
BYTE_SENDEN_TEMP1:
	sbis UCSRA,UDRE  		   	; Warten bis UDR frei             	
	rjmp BYTE_SENDEN_TEMP1		; Sprung							
	out UDR, temp1				; senden							
	; kleine PAUSE (nur wenn mehrere Bytes nacheinander gesendet werden mssen)		
	;rcall wait_1ms

ret
; ##############################################################################
; ##############################################################################
; ##############################################################################
; Interruptroutine: wird ausgefhrt sobald ein Byte ber das UART empfangen wurde
BYTE_EINLESEN:
	push TEMP		    ; Sichern von "TEMP" im Stack
	in	 TEMP,SREG		; Einlesen des SREG 
	push TEMP	    	; Schreiben von  SREG  im Stack (KOPIE)
	push TEMP1
; ------------------------------------------------------------------------------
	LDS temp,(adr_RS232_ANZAHL_BYTES)
	inc temp
	STS (adr_RS232_ANZAHL_BYTES),temp

	cpi temp,1
	breq BYTE_EINLESEN_1
	cpi temp,2
	breq BYTE_EINLESEN_2
	cpi temp,3
	breq BYTE_EINLESEN_3
	rjmp BYTE_EINLESEN_ERROR
; ------------------------------------------------------------------------------
; muss ein "*" sein	(Vorhut)													
BYTE_EINLESEN_1:
	in temp, UDR 	; BYTE einlesen	
	cpi temp,'*'
	breq BYTE_EINLESEN_FERTIG
	rjmp BYTE_EINLESEN_ERROR
; ------------------------------------------------------------------------------
BYTE_EINLESEN_2:
	in temp, UDR 	; BYTE einlesen	
	STS(adr_RS232_KOMMANDO1),temp
	rjmp BYTE_EINLESEN_FERTIG
; ------------------------------------------------------------------------------
BYTE_EINLESEN_3:
	in temp, UDR 	; BYTE einlesen	
	STS(adr_RS232_KOMMANDO2),temp
	rjmp BYTE_EINLESEN_FERTIG
; ------------------------------------------------------------------------------
BYTE_EINLESEN_ERROR:
	STS (adr_RS232_ANZAHL_BYTES),NULL

; -------------------------------
BYTE_EINLESEN_FERTIG:
	pop TEMP1
	pop	TEMP			; LESEN von SREG vom STACK (KOPIE)
	out	SREG,TEMP		; Wiederherstellen von SREG
	pop	TEMP			; Wiederherstellen von "TEMP" 		
reti              
; ##############################################################################
; ##############################################################################
; ##############################################################################

